# coding: utf-8

"""
    Midgard Public API

    The Midgard Public API queries THORChain and any chains linked via the Bifröst and prepares information about the network to be readily available for public users. The API parses transaction event data from THORChain and stores them in a time-series database to make time-dependent queries easy. Midgard does not hold critical information. To interact with THORChain protocol, users should query THORNode directly.  # noqa: E501

    OpenAPI spec version: 2.31.0
    Contact: devs@thorchain.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RUNEPoolHistoryItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'count': 'str',
        'depth': 'str',
        'end_time': 'str',
        'start_time': 'str',
        'units': 'str'
    }

    attribute_map = {
        'count': 'count',
        'depth': 'depth',
        'end_time': 'endTime',
        'start_time': 'startTime',
        'units': 'units'
    }

    def __init__(self, count=None, depth=None, end_time=None, start_time=None, units=None):  # noqa: E501
        """RUNEPoolHistoryItem - a model defined in Swagger"""  # noqa: E501
        self._count = None
        self._depth = None
        self._end_time = None
        self._start_time = None
        self._units = None
        self.discriminator = None
        self.count = count
        if depth is not None:
            self.depth = depth
        self.end_time = end_time
        self.start_time = start_time
        self.units = units

    @property
    def count(self):
        """Gets the count of this RUNEPoolHistoryItem.  # noqa: E501

        Int64, Number of RUNEPool members in the pool at the end of the interval  # noqa: E501

        :return: The count of this RUNEPoolHistoryItem.  # noqa: E501
        :rtype: str
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this RUNEPoolHistoryItem.

        Int64, Number of RUNEPool members in the pool at the end of the interval  # noqa: E501

        :param count: The count of this RUNEPoolHistoryItem.  # noqa: E501
        :type: str
        """
        if count is None:
            raise ValueError("Invalid value for `count`, must not be `None`")  # noqa: E501

        self._count = count

    @property
    def depth(self):
        """Gets the depth of this RUNEPoolHistoryItem.  # noqa: E501

        Int64(e8), The depth in the RUNEPool vault at the end of the interval  # noqa: E501

        :return: The depth of this RUNEPoolHistoryItem.  # noqa: E501
        :rtype: str
        """
        return self._depth

    @depth.setter
    def depth(self, depth):
        """Sets the depth of this RUNEPoolHistoryItem.

        Int64(e8), The depth in the RUNEPool vault at the end of the interval  # noqa: E501

        :param depth: The depth of this RUNEPoolHistoryItem.  # noqa: E501
        :type: str
        """

        self._depth = depth

    @property
    def end_time(self):
        """Gets the end_time of this RUNEPoolHistoryItem.  # noqa: E501

        Int64, The end time of bucket in unix timestamp  # noqa: E501

        :return: The end_time of this RUNEPoolHistoryItem.  # noqa: E501
        :rtype: str
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this RUNEPoolHistoryItem.

        Int64, The end time of bucket in unix timestamp  # noqa: E501

        :param end_time: The end_time of this RUNEPoolHistoryItem.  # noqa: E501
        :type: str
        """
        if end_time is None:
            raise ValueError("Invalid value for `end_time`, must not be `None`")  # noqa: E501

        self._end_time = end_time

    @property
    def start_time(self):
        """Gets the start_time of this RUNEPoolHistoryItem.  # noqa: E501

        Int64, The beginning time of bucket in unix timestamp  # noqa: E501

        :return: The start_time of this RUNEPoolHistoryItem.  # noqa: E501
        :rtype: str
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this RUNEPoolHistoryItem.

        Int64, The beginning time of bucket in unix timestamp  # noqa: E501

        :param start_time: The start_time of this RUNEPoolHistoryItem.  # noqa: E501
        :type: str
        """
        if start_time is None:
            raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def units(self):
        """Gets the units of this RUNEPoolHistoryItem.  # noqa: E501

        Int64, Units in the RUNEPool vault at the end of the interval   # noqa: E501

        :return: The units of this RUNEPoolHistoryItem.  # noqa: E501
        :rtype: str
        """
        return self._units

    @units.setter
    def units(self, units):
        """Sets the units of this RUNEPoolHistoryItem.

        Int64, Units in the RUNEPool vault at the end of the interval   # noqa: E501

        :param units: The units of this RUNEPoolHistoryItem.  # noqa: E501
        :type: str
        """
        if units is None:
            raise ValueError("Invalid value for `units`, must not be `None`")  # noqa: E501

        self._units = units

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RUNEPoolHistoryItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RUNEPoolHistoryItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
