# coding: utf-8

"""
    Midgard Public API

    The Midgard Public API queries THORChain and any chains linked via the Bifröst and prepares information about the network to be readily available for public users. The API parses transaction event data from THORChain and stores them in a time-series database to make time-dependent queries easy. Midgard does not hold critical information. To interact with THORChain protocol, users should query THORNode directly.  # noqa: E501

    OpenAPI spec version: 2.31.0
    Contact: devs@thorchain.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RUNEPoolHistoryMeta(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'end_count': 'str',
        'end_time': 'str',
        'end_units': 'str',
        'start_count': 'str',
        'start_time': 'str',
        'start_units': 'str'
    }

    attribute_map = {
        'end_count': 'endCount',
        'end_time': 'endTime',
        'end_units': 'endUnits',
        'start_count': 'startCount',
        'start_time': 'startTime',
        'start_units': 'startUnits'
    }

    def __init__(self, end_count=None, end_time=None, end_units=None, start_count=None, start_time=None, start_units=None):  # noqa: E501
        """RUNEPoolHistoryMeta - a model defined in Swagger"""  # noqa: E501
        self._end_count = None
        self._end_time = None
        self._end_units = None
        self._start_count = None
        self._start_time = None
        self._start_units = None
        self.discriminator = None
        self.end_count = end_count
        self.end_time = end_time
        self.end_units = end_units
        self.start_count = start_count
        self.start_time = start_time
        self.start_units = start_units

    @property
    def end_count(self):
        """Gets the end_count of this RUNEPoolHistoryMeta.  # noqa: E501

        Int64, Number of RUNEPool member in the RUNEPool vault at the end of the interval at time endTime  # noqa: E501

        :return: The end_count of this RUNEPoolHistoryMeta.  # noqa: E501
        :rtype: str
        """
        return self._end_count

    @end_count.setter
    def end_count(self, end_count):
        """Sets the end_count of this RUNEPoolHistoryMeta.

        Int64, Number of RUNEPool member in the RUNEPool vault at the end of the interval at time endTime  # noqa: E501

        :param end_count: The end_count of this RUNEPoolHistoryMeta.  # noqa: E501
        :type: str
        """
        if end_count is None:
            raise ValueError("Invalid value for `end_count`, must not be `None`")  # noqa: E501

        self._end_count = end_count

    @property
    def end_time(self):
        """Gets the end_time of this RUNEPoolHistoryMeta.  # noqa: E501

        Int64, The end time of bucket in unix timestamp  # noqa: E501

        :return: The end_time of this RUNEPoolHistoryMeta.  # noqa: E501
        :rtype: str
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this RUNEPoolHistoryMeta.

        Int64, The end time of bucket in unix timestamp  # noqa: E501

        :param end_time: The end_time of this RUNEPoolHistoryMeta.  # noqa: E501
        :type: str
        """
        if end_time is None:
            raise ValueError("Invalid value for `end_time`, must not be `None`")  # noqa: E501

        self._end_time = end_time

    @property
    def end_units(self):
        """Gets the end_units of this RUNEPoolHistoryMeta.  # noqa: E501

        Int64,  Units in the RUNEPool vault at the end of the interval at time endTime  # noqa: E501

        :return: The end_units of this RUNEPoolHistoryMeta.  # noqa: E501
        :rtype: str
        """
        return self._end_units

    @end_units.setter
    def end_units(self, end_units):
        """Sets the end_units of this RUNEPoolHistoryMeta.

        Int64,  Units in the RUNEPool vault at the end of the interval at time endTime  # noqa: E501

        :param end_units: The end_units of this RUNEPoolHistoryMeta.  # noqa: E501
        :type: str
        """
        if end_units is None:
            raise ValueError("Invalid value for `end_units`, must not be `None`")  # noqa: E501

        self._end_units = end_units

    @property
    def start_count(self):
        """Gets the start_count of this RUNEPoolHistoryMeta.  # noqa: E501

        Int64, Number of RUNEPool member in the RUNEPool vault at the start of the interval at time startTime   # noqa: E501

        :return: The start_count of this RUNEPoolHistoryMeta.  # noqa: E501
        :rtype: str
        """
        return self._start_count

    @start_count.setter
    def start_count(self, start_count):
        """Sets the start_count of this RUNEPoolHistoryMeta.

        Int64, Number of RUNEPool member in the RUNEPool vault at the start of the interval at time startTime   # noqa: E501

        :param start_count: The start_count of this RUNEPoolHistoryMeta.  # noqa: E501
        :type: str
        """
        if start_count is None:
            raise ValueError("Invalid value for `start_count`, must not be `None`")  # noqa: E501

        self._start_count = start_count

    @property
    def start_time(self):
        """Gets the start_time of this RUNEPoolHistoryMeta.  # noqa: E501

        Int64, The beginning time of bucket in unix timestamp  # noqa: E501

        :return: The start_time of this RUNEPoolHistoryMeta.  # noqa: E501
        :rtype: str
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this RUNEPoolHistoryMeta.

        Int64, The beginning time of bucket in unix timestamp  # noqa: E501

        :param start_time: The start_time of this RUNEPoolHistoryMeta.  # noqa: E501
        :type: str
        """
        if start_time is None:
            raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def start_units(self):
        """Gets the start_units of this RUNEPoolHistoryMeta.  # noqa: E501

        Int64,  Units in the RUNEPool vault at the start of the interval at time startTime   # noqa: E501

        :return: The start_units of this RUNEPoolHistoryMeta.  # noqa: E501
        :rtype: str
        """
        return self._start_units

    @start_units.setter
    def start_units(self, start_units):
        """Sets the start_units of this RUNEPoolHistoryMeta.

        Int64,  Units in the RUNEPool vault at the start of the interval at time startTime   # noqa: E501

        :param start_units: The start_units of this RUNEPoolHistoryMeta.  # noqa: E501
        :type: str
        """
        if start_units is None:
            raise ValueError("Invalid value for `start_units`, must not be `None`")  # noqa: E501

        self._start_units = start_units

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RUNEPoolHistoryMeta, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RUNEPoolHistoryMeta):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
